<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:util="in.co.sahi.util.XSLUtils"
				version="1.0">
	<xsl:output method="html" indent="yes" />
	<xsl:param name="useDBURL" select="false" />
	<xsl:param name="inlineJS" select="false" />

	<xsl:template match="suites">
		<html>
			<head>
				<meta http-equiv="content-type" content="text/html; charset=UTF-8" />

				<xsl:value-of select="document('jquery.treetable.dependency')" disable-output-escaping="yes" />
				<xsl:choose>
					<xsl:when test="$useDBURL = 'true'">
						<link rel="shortcut icon" href="/_s_/spr/images/favicon.ico" type="image/png"/>
						<script type="text/javascript" src="/_s_/spr/util.js"></script>
						<script type="text/javascript" src="/_s_/spr/login/logout.js"></script>
						<script type="text/javascript" src="/_s_/spr/ext/easyui/jquery.easyui.min.js"></script>
						<script src="/_s_/spr/ext/codemirror/lib/codemirror.js"></script>
						<link rel="stylesheet" href="/_s_/spr/ext/codemirror/lib/codemirror.css"/>
						<script src="/_s_/spr/ext/codemirror/mode/javascript/javascript.js"></script>
						<script type="text/javascript" src="/_s_/spr/codemirror_wrapper.js"></script>
						<script type="text/javascript"> 
						   $(window).load(function () {
						      if(sahiIsIE()){
						         let bannerId = document.getElementById('banner');
						         bannerId.style.display = 'inline-flex';
						      }
						   });
						</script>
						<link rel="stylesheet" type="text/css" href="/_s_/spr/ext/easyui/themes/gray/easyui.css" />
						<link rel="stylesheet" href="/_s_/spr/css/reports_styles.css" type="text/css" />
						<xsl:value-of select="document('graph.offline.dependency')" disable-output-escaping="yes" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="document('codemirror.js.dependency')" disable-output-escaping="yes" />
						<xsl:value-of select="document('codemirror.css.dependency')" disable-output-escaping="yes" />
						<xsl:value-of select="document('codemirror.javascript.dependency')" disable-output-escaping="yes" />
						<xsl:value-of select="document('codemirror.wrapper.js.dependency')" disable-output-escaping="yes" />
						
						<link href="common.css" rel="stylesheet" type="text/css" />
						<link href="styles.css" rel="stylesheet" type="text/css" />
						<xsl:if test="not($inlineJS='true')">
							<script src="common.js"></script>
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="$inlineJS = 'true'">
					<xsl:value-of select="document('easyui.min.js.dependency')" disable-output-escaping="yes" />
					<xsl:value-of select="document('graph.offline.dependency')" disable-output-escaping="yes" />
				</xsl:if>

				<style><![CDATA[
					.flex-row {
					display: flex;
					flex-direction: row;
					gap: 10px;
					align-items: center;
					}

					.flex-column {
					display: flex;
					flex-direction: column;
					gap: 10px;
					align-items: center;
					}

					.container {
					margin-left: 60px;
					margin-right: 60px;
					margin-bottom: 40px;
					margin-top: 25px;
					}

					.logo-header .container {
						--darker: #f8f8f8;
						box-sizing: border-box;
						display: flex;
						flex-direction: row;
						align-items: center;
						gap: 8px;
						cursor: pointer;
						padding: 8px 16px;
						background: #FFFFFF;
						border: 1px solid #4E4E4E;
						border-radius: 15px;
					    background: transparent;
					    border-color: #FFF;
					    margin: 0;
					}
					.container img {
					    height: 16px;
					    width: 16px;
					}
					.logo-header .container span {
					    color: #FFF;
					}

					.logo-header {
					position: fixed;
					left: 0;
					top: 0;
					height: 50px;
					background-color: #253F89;
					z-index: 3;
					}

					#sahi-logo {
					display: inline-block;
					width: 110px;
					height: 50px;
					margin: 0;
					padding: 0;
					}

					#navbar a:not(.nav-sahi-logo){
					color: #D3D3D3;
					text-decoration: none;
					font-size: 14px;
					font-weight: 700;
					}

					#navbar a.selected {
					font-weight: 700;
					background-color: white;
					padding: 13px 25px 0 25px;
					border-bottom: none;
					margin-bottom: -1px;
					height: 65%;
					color: #253F89;
					border-radius: 5px 5px 0px 0px;
					}

					#navbar > div:last-child {
					gap: 10px;
					}

					#navbar {
						position: sticky;
						left: 0;
						
						width: 100%;
						max-width: 98.5vw;
						min-width: 1200px;
						
						height:50px;
						padding: 0;

						align-items: flex-end;
						justify-content: space-between;
					}

					#navbar > .left-nav {
						padding: 0 0 0 35px;
						gap: 10px;
						height: 100%;
						align-items: flex-end;
					}

					#navbar > .right-nav {
						margin-right: 20px;
						align-self: center;
					}

					.navbar-container {
						position: sticky;
						top: 0px;

						margin: 0;
						padding: 0;
						margin-top: 0px;

						background-color: #253F89;
						width: 100%;
						min-width: 100vw;
						z-index: 3;	
					}

					body{display:table;min-width:99%;}
					a{text-decoration:none;color:white;}
					a.details{text-decoration:underline;color: blue;}
					a.INFO{color:black}
					a.START,a.STOP{color:black;font-weight:bold;}
					div.INFO{background-color:white}
					div.SUCCESS{background-color:green;color:white}
					div.FAILURE,div.ERROR{background-color:red;color:white}
					a.CUSTOM,
					a.CUSTOM2, a.CUSTOM4{color:black}
					div.CUSTOM{background-color:yellow;}
					div.CUSTOM1{background-color:orange;}
					div.CUSTOM2{background-color:#EFEFEF;}
					div.CUSTOM3{background-color:green;}
					div.CUSTOM4{background-color:violet;}
					div.CUSTOM5{background-color:indigo;}
					a.SCRIPT{text-decoration:underline;}
					span.extra{color:#CCC;}
					div.SKIPPED{background-color:#eed;}
					a.SKIPPED{color:gray;}

					table.scriptSummaries{border-top:1px solid #ccc;border-right:1px solid #ccc;border-spacing:0px;border-collapse:collapse;}
					table.scriptSummaries td,th{
					border-bottom:1px solid #ccc;
					border-left:1px solid #ccc;
					padding:8px 12px;
					}
					table#failedSuiteByLines td{vertical-align:top;}
					.suite_summary_part tr.FAILURE{background-color:red;color:white;}
					.suite_summary_part tr.SUCCESS{background-color:green;color:white;}
					.suite_summary_part tr.RUNNING{background-color:orange;color:black;}
					.suite_summary_part tr.ABORTED,.suite_summary_part tr.USER_ABORTED,.suite_summary_part tr.ABORTED_TIMEOUT{background-color:brown;color:white;}
					a{color:black;}
					tr.RUNNING a {color:black;}
					table.suite_summary {border:1px solid orange; margin-bottom:30px;background-color:#fff;width:655px;}
					table.suite_summary td {vertical-align:top;padding:3px;text-align:left;}
					table.suite_summary_part {border:0px;}
					table.suite_summary_part *{border:0px;spacing:0px;}

					body *{font-family: Arial, Helvetica, sans-serif;font-size:10pt;}
					body {margin:0px; background-color:white;}

					.step_multiple_failure{display: inline-block;float: left;position: relative;top: 2.9px;}

					.footnote{font-size:smaller;font-weight:400;margin:5px 5px -4px 0px;}

					.no-border {
					border: 0;
					position: absolute;
					right: 0.5px;
					border-top: 1px solid #ccc;
					border-left: 1px solid #ccc;
					border-right: 1px solid #ccc;
					bottom: 0;
					}

					table.no-border td{
					border: 0;
					border-bottom:0;
					border-top:0;
					}

					.node .ste {
					cursor: pointer;
					}

					tspan{font: 12px Arial,Helvetica,sans-serif;}

					.node circle {
					fill: #fff;
					stroke: steelblue;
					stroke-width: 3px;
					}

					.node text {
					font: 12px Arial,Helvetica,sans-serif;
					cursor: context-menu;
					}

					.link {
					fill: none;
					stroke: #ccc;
					stroke-width: 2px;
					}

					.scrollable {
					width: 100%;
					height: 100%;
					padding-left: 14px;
					overflow: hidden auto;
					max-height:100px;
					}

					.scrollable>a{
						display: list-item;
						float:left;
						clear:both;
						width:fit-content;
						margin:3px;
						text-decoration: none;
					}

					.scrollable>a:hover{text-decoration:underline;}

					.failure-history-latest-status,
					.failure-history-all-status,
					.success-history-latest-status,
					.success-history-all-status {
					display: flex;
					flex-wrap: wrap;
					max-width: 350px;
					}

					.success-history-latest-status,
					.success-history-all-status {
					max-width: 375px;
					text-align: center;
					}

					.suite-analysis-header {
					font-size: 20px;
					line-height: 24px;
					color: #253F89;
					}

					.suite-summary {
					width: max(30vw, 600px);
					min-width: 450px;
					max-width: max(30vw, 600px);
					border: 0.5px solid #ccc;
					border-radius: 10px;
					padding: 10px;
					margin-top: 20px;
					}

					.suite-name {
					justify-content: space-between;
					padding-top: 20px;
					padding-left: 10px;
					padding-right: 20px;

					font-size: 16px;
					line-height: 20px;
					}

					.suite-name > span > span {
					opacity: 0.7;
					font-weight: bold;
					padding-right: 10px;
					font-size: 16px;
					white-space: nowrap;
					}

					.suite-name a {
					opacity: 1;
					font-weight: bold;
					color: #000;
					font-size: 16px;
					overflow-wrap: break-word;
					max-width: max(24vw, 450px);
					}

					.suite-details {
					margin-top: 25px;
					align-items: stretch;
					gap: 10px;
					}

					.suite-detail-group {
					align-self: flex-start;
					padding: 5px 10px 10px 10px;

					display: flex;
					flex-direction: row;
					width: 100%;
					}

					.suite-details-right .suite-detail-group{
					gap: 5px;
					}

					.suite-info {
					margin-top: 20px;
					margin-bottom: 10px;
					}

					.nodes-info {
					margin-bottom: 35px;
					}

					/*.suite-info a,
					.nodes-info a {
					color: black;
					}*/

					.suite-detail-group {
						font-size: 16px !important;
						line-height: 19px;
						align-self: flex-start;
					}

					.suite-details-left .suite-detail-item-title {
						flex-basis: 60%;
					}
					
					.suite-detail-item-title {
					font-weight: bold;
					opacity: 0.7;
					flex-basis: 80%;
					font-size: 14px;
					}

					.suite-detail-item-title:has(+ span#status) {
					flex-basis: 30%;
					align-self: center;
					}

					span#status {
					align-self: center;
					text-transform: capitalize;
					}

					.suite-detail-item-value {
					flex-basis: 100%;
					font-weight: 600;
					font-size: 14px !important;
					}

					.suite-detail-item-value .flex-column > span:first-child {
						font-weight: 600;
						font-size: 14px !important;
					}

					.suite-details-right .suite-detail-item-value span:first-child:not(.status-icon) {
						display: inline-block;
						width: 3ch;
						text-align: right;
						font-size: 14px;
					}

					.suite-details-left,
					.suite-details-right {
					flex-basis: 100%;
					}

					.suite-details-right-title {
						margin-left: 20%;
					}
					
					.suite-details-right-title h2 {
						margin: 13px 0;
						font-size: 16;
					}

					#suiteInfo {
					padding: 10px;
					border: 1px solid black;
					border-radius: 10px;
					background-color: white;
					width: fit-content;
					}

					#suiteInfo,
					#nodesInfo {
					margin-top: 20px;
					margin-left: 30px;
					}

					.suiteInfoLink,
					.nodesInfoLink {
					color: #000;
					text-decoration: none;

					font-size: 15px;
					line-height: 19px;
					font-weight: bold;
					gap: 0;
					display: inline-flex;
					}

					.suiteInfoLink::before,
					.nodesInfoLink::before {
					content: '';
					display: inline-block;

					height: 20px;
					width: 20px;

					margin-right: 10px;
					transform: rotate(-90deg);
					}

					.suiteInfoLink.expanded::before,
					.nodesInfoLink.expanded::before {
					transform: rotate(0deg);
					}

					.date-time .flex-column {
						align-items: flex-start;
						gap: 5px;
					}

					.date-time > span >span:last-child {
						font-size: 12px;
						font-weight: 500;
						color: #4E4E4E;
					}

					table, th, td {
					border: none;
					border-spacing: 0;
					border-collapse: collapse;
					}

					.table-header {
					width: 100%;
					}

					.table-header th {
					background-color: #E2EAFF !important;
					border: 0.5px solid #66666682 !important;

					color: #000 !important;
					font-family: Arial, Helvetica, sans-serif;
					font-weight: bold !important;

					padding: 11px 15px 11px 10px !important;

					text-align: left;
					white-space: nowrap !important;
					}

					.table-header th[colspan],
					.table-header:nth-child(2) th {
						text-align: center;
					}

					/* use this class on table data rows only */
					.table-data td {
					border: 0.5px solid #66666682 !important;
					color: #000 !important;
					font-family: Arial, Helvetica, sans-serif;

					padding: 11px 15px 11px 10px !important;
					min-width: 100px !important;

					text-align: left !important;
					}

					td.right-align {
						text-align: right !important;
					}

					td {
						font-weight: 500;
					}

					.icon-group {
					padding: 10px;
					border: 1px solid #4e4e4e;
					border-radius: 15px;
					color: #4e4e4e;
					}

					.icon-group::before {
					content: '';
					display: inline-block;

					width: 16px;
					height: 16px;

					background-image: url('/_s_/spr/images/fi-sr-refresh.svg');
					background-size: contain;
					background-repeat: no-repeat;
					}

					.icon-group input[type="checkbox"] {
					display: none;
					}

					.auto-refresh * {
					cursor: pointer;
					}

					.status-icon {
					border: 1.5px solid black;
					border-radius: 15px;

					font-weight: bold;
					padding: 8px 12px !important;
					max-width: fit-content;

					margin: 10px 5px;
					text-transform: capitalize;
					}

					.status-icon::before {
					content: '';
					display: inline-block;

					width: 16px;
					height: 16px;

					background-size: contain;
					background-repeat: no-repeat;

					}

					.failure-step {
					font-weight: bold;
					}

					.failure-step a {
					color: #092572;
					}

					.num-failures-healed {
					margin-top: 40px;
					}

					.button-view-tree {
					display: inline;
					margin-left: 40px;
					}

					.button-view-tree a {
					text-decoration: none;
					font-weight: bold;
					color: #000;
					}

					.failureStepMessages .panel-body {
					border: 0;
					margin-top: 20px;
					/*min-height: 300px;*/
					height: fit-content !important;
					max-height: max(600px, 50vh);
					}

					.failureStepMessages .panel-body table {
					bottom: 10px;
					border: none;
					}

					.failed-scripts-table {
					border: 1px solid #666666;
					border-radius: 5px;
					right: 20px;
					/*left: 0;*/
					bottom: 20px;
					padding: 2px;

					position: absolute;
					width: max-content;
					z-index: 2;
					}

					.row .easyui-panel {
						padding-bottom: 150px !important;
					}

					.failed-scripts-table thead > tr {
					border-bottom: 0.5px solid #66666640;
					}

					td.failed_scripts {
					border: none !important;
					}

					td.failed_scripts a.SCRIPT {
					list-style: disc;
					color: #666666;
					/*max-width: 150px;*/
					text-align: left;
					padding-right: 5px;
					}

					td.failed_scripts a.SCRIPT span {
						display: inline-block;
						color: #092572;
						font-weight: bold;
						max-width: 20ch;
						overflow: hidden;
						text-overflow: ellipsis;
						vertical-align: middle;
					}

					g.node circle {
					fill: #3355B8;
					stroke: #3355B8;
					}

					g.node text:first-of-type {
					fill: white;
					}

					g.node text.ste {
					fill: #092572;
					font-weight: bold;
					font-size: 14px;
					}

					g.node text.ste tspan {
					fill: black;
					}

					#expandAllButton,
					#collapseAllButton {
					cursor: pointer;
					color: #4e4e4e;
					padding-right: 20px;
					font-weight: bold;
					}

					#expandAllButton {
					margin-left: 20px;
					}

					.report-options-checkbox {
					font-weight: bold;
					}

					.report-options-checkbox .checkbox-group {
					margin-left: 20px;
					}

					.checkbox-group input {
					margin-left: 10px;
					}

					.checkbox-group input[type="checkbox"] {
					appearance: none;

					background-color: #fff;
					margin: 0;

					font: inherit;
					color: white;
					width: 18px;
					height: 18px;
					border: 2px solid #46474aa3;
					border-radius: 3px;

					display: grid;
					place-content: center;
					}


					.checkbox-group input[type="checkbox"]::before {
					content: '';
					display: inline-block;
					width: 16px;
					height: 16px;
					box-shadow: inset 14px 14px #fff;

					transform: scale(0);
					transition: transform 120ms ease-in-out;
					transform-origin: bottom left;
					clip-path: polygon(13% 45%, 37% 65%, 83% 1%, 99% 14%, 39% 98%, 0 64%);
					}

					.checkbox-group input[type="checkbox"]:checked {
					background-color: #092572;
					}

					.checkbox-group input[type="checkbox"]:checked::before {
					/* background-color: #092572; */
					transform: scale(1);
					}

					.checkbox-group:has(input[type="checkbox"]:checked) label {
					color: #092572;
					}

					.checkbox-group:has(input[type="checkbox"]:checked) {
					border-color: #092572;
					border-width: 2px;
					}

					a:hover {
						text-decoration: underline !important;
					}

					#navbar a:not(.nav-sahi-logo):hover {
						text-decoration: none !important;
					}

					#navbar > .left-nav a:not(.selected, .nav-sahi-logo) {
						padding: 11px 24px 11px 24px;
					    margin-bottom: 3px;
					    border-radius: 5px;
				    }
					
					#navbar > .left-nav a:not(.selected, .nav-sahi-logo):hover {
						background-color: #E2EAFF;
						color: #253F89;
					}
					#jsCodeCoverage {
					    height: 61%;
					}

					.retry-count {
						font-weight: 600;
						font-size: 14;
						border: 2px solid;
						border-color: inherit;
						border-radius: 9999px;
						width: 24px;
						height: 24px;
						display: inline-flex;
						justify-content: space-around;
					}

					table.scriptSummaries .easyui-panel.flex-column {
						align-items: flex-start;
						justify-content: space-between;
					}

					.script-name span {
						display: inline-block;
						max-width: 40ch;
						overflow: hidden;
						text-overflow: ellipsis;
						white-space: nowrap;
					}

					.script-name span:hover {
						text-decoration: underline;
					}

					.scriptSummaries .script-name span:hover {
						text-decoration: none;
					}

					.panel.window {
						background: white;
						padding-left: 10px;
						padding-right: 10px;
						padding-bottom: 15px;
					}

					.panel.window .panel-header {
						padding: 10px 10px;
						border: none;
					}

					.panel.window .panel-tool-close {
						background: none !important;
						background-image: url('/_s_/spr/images/fi-rr-cross.svg') !important;
						background-size: contain !important;
						background-repeat: no-repeat;
						width: 20px !important;
						height: 20px !important;
					}

					.panel.window .panel-title {
						font-size: 16px;
					}

					#all_steps_div {
						border: 1px solid #d3d3d3;
						border-radius: 8px;
					}
					#banner {
					   position: fixed;
					   display:none;
					   top: 0; left: 25%;
					   border-left: 8px solid #E62E2D;
					   border-radius: 10px;
					   background-color: #FFE6E5;
					   z-index: 100;width: 630px;
					   box-shadow: 0px 4px 14px 0px #5f5f5f;
					}
					#banner img {margin-top: 15px; margin-left: 10px; height: 40px}
					.warn { margin: 12px; line-height: 24px }
					.warn span, .warn strong {font-size: 16px}
					#warn {color: red}
				]]></style>
				<title><xsl:value-of select="suite/suiteSummary/SUITENAME"/></title>
			</head>

			<body onunload="onUnload()" onload="onLoad()">
				<script><![CDATA[
					// functions for formatting the date and time columns
					function splitDateTime(datetime) {
						var ix = datetime.search(/\d+:\d+:\d+/);
						if (ix < 0) return null;
						var date = datetime.substr(0, ix-1), time = datetime.substr(ix);
						return [date, time.toUpperCase()];
					}

					function splitStartAndEndTimeColumns() {
						var dateTimes = document.querySelectorAll('.date-time');
						var dateTimeRegex = /[a-zA-Z]{3} \d+, \d{4} \d+:\d+:\d+ [a-zA-Z]{2}/;

						var dateTimeHTML = el => {
							var datetime = el.dataset.text;
							if (!datetime || !datetime.match(dateTimeRegex)) {
								el.innerHTML = datetime;
								return;
							}

							var parts = splitDateTime(datetime);
							if (parts)
								el.innerHTML = "<span class='flex-column'>" + parts.map(x => "<span>" + x + "</span>").join("") + "</span>";
						}

						dateTimes.forEach(dateTimeHTML);
					}

					function formatTimeTakenColumn() {
						const timeRegex = /\d+:\d+:\d+ \d+/
						const timeSplitRegex = /:|\s/
						document.querySelectorAll('.time-taken').forEach(el => {
							const elText = el.dataset.text;
							if (elText.match(timeRegex)) {
								const arr = elText.split(timeSplitRegex)
								let formattedTime = [];
								
								if (!arr[0].match(/^0+$/)) 
									formattedTime.push(arr[0].padStart(2,0));
								formattedTime.push(arr[1].padStart(2,0));
								formattedTime.push(arr[2].padStart(2,0));
								let ms = arr[3].padStart(3,0);
								
								if (!formattedTime) formattedTime = '00:00.000';
								else formattedTime = formattedTime.join(':');
								formattedTime += "."+ms;
								el.innerHTML = formattedTime;
							}
						})
					}	
				]]></script>
				<script><![CDATA[
					function showFullScriptStatuses(elSelector, dataOption) {
						var els = document.querySelectorAll(elSelector);
						els.forEach(el => {
							var statuses = el.dataset.options;
							if (!statuses) return;
							var fullStatuses = statuses.split(/\s*,\s*/).map(s => {
								let finalTag = s.startsWith('F')
								? "<span class='FAILURE status-icon flex-row'>Failure"
								: "<span class='SUCCESS status-icon flex-row'>Success";

								if (s.length > 1) {
									const retryCount = s.slice(1);
									finalTag += "<span class='retry-count flex-column'>" + retryCount + "</span>";
								}

								finalTag += "</span>";

								return finalTag;
							}).join("")
							el.innerHTML = fullStatuses
						});
					}
				]]></script>
				<xsl:apply-templates select="suite/suiteSummary"/>
				<div class='container'>
					<xsl:apply-templates select="suite/failures"/>
					<xsl:apply-templates select="suite/failureHistory"/>
					<xsl:apply-templates select="suite/successHistory"/>
				</div>
				<script>
					jQuery(function(){
					createTextCMEditor("failuresText", true, "javascript", true);
					});
					function minimizeScript(){
					var innerHTML = this.innerHTML;
					var index = innerHTML.lastIndexOf('/');
					this.innerHTML = innerHTML.substring(index+1);
					}
					$(".failed_file").each(minimizeScript);
					<![CDATA[
						function showHideReports(el){
							var healedReportEl = document.getElementById("healedReport");
							var failureReportEl = document.getElementById("failureReport");
							var currentSuiteEl = document.getElementById("shownReportsText");
							if(!healedReportEl.checked && !failureReportEl.checked){
								currentSuiteEl.style.display = "none";
							}else if(currentSuiteEl.style.display == "none"){
								currentSuiteEl.style.display = "block";
							}
							var displayValue = el.checked ? "table-row" : "none";
							var steps;
							var selectedReportText = "";
							if(el.value == "healedReport"){
								steps = document.getElementsByClassName("row HEALED");
							}else if(el.value == "failureReport"){
								steps = document.getElementsByClassName("row FAILURE");
							}
							if(healedReportEl.checked && failureReportEl.checked){
								selectedReportText = "Failure & Healed ";
							}else if(healedReportEl.checked){
								selectedReportText = "Healed ";
							}else if(failureReportEl.checked){
								selectedReportText = "Failure ";
							}
							document.getElementById("selectedReport").innerHTML = selectedReportText;
							for(var i = 0; i<steps.length; i++){
								steps[i].style.display = displayValue;
							}
						}
					]]>
				</script>
				<div id="all_steps_div" class="easyui-window" style="width:50%;padding:9px;max-height:500px;" title=' All step messages' data-options="shadow:false,modal:true,collapsible:false,minimizable:false,maximizable:false,closed:true,draggable:true">
					<textarea id="failuresText"></textarea>
				</div>
				<span id="go-to-top" title="Scroll to Top"></span>
				<script><![CDATA[
					document.addEventListener('scroll', () => {
						const rootElement = document.body;
						const goToTopBtn = document.getElementById('go-to-top');
						let scrollTotal = rootElement.scrollHeight - rootElement.clientHeight;
						let scrollPct = rootElement.scrollTop/scrollTotal;
						if(document.body.scrollTop < 1.5*rootElement.clientHeight) {
							goToTopBtn.style.display = 'none';
						} else {
							goToTopBtn.style.display = 'inline-block';
						}
					});
			
					document.querySelector('#go-to-top')
						.addEventListener('click', () => {
							var rootElement = document.body;
							rootElement.scrollTo({
								top: 0,
								behavior: "smooth"
							})
						});
				]]></script>
			</body>
		</html>
	</xsl:template>
	<xsl:template name="tokenizeString">
		<xsl:param name="scripts"/>
		<xsl:param name="reportids"/>
		<xsl:param name="delimiter"/>
		<xsl:choose>
			<xsl:when test="contains($scripts, $delimiter)">
				<xsl:choose>
					<xsl:when test="$useDBURL = 'true'">
						<a class="SCRIPT script-name" target="_blank" href="/_s_/dyn/pro/DBReports_scriptReport?id={substring-before($reportids,$delimiter)}">
							<span>
								<xsl:attribute name="title">
									<xsl:value-of select="substring-before($scripts,$delimiter)" />
								</xsl:attribute>
								<xsl:text>
									<xsl:value-of select="substring-before($scripts,$delimiter)" />
								</xsl:text>
							</span>
						</a>
					</xsl:when>
					<xsl:otherwise>
						<a class="SCRIPT script-name" target="_blank" href="{substring-before($reportids,$delimiter)}.html">
							<span>
								<xsl:attribute name="title">
									<xsl:value-of select="substring-before($scripts,$delimiter)" />
								</xsl:attribute>
								<xsl:text>
									<xsl:value-of select="substring-before($scripts,$delimiter)" />
								</xsl:text>
							</span>
						</a>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="tokenizeString">
					<!-- store anything left in another variable -->
					<xsl:with-param name="scripts" select="substring-after($scripts,$delimiter)"/>
					<xsl:with-param name="reportids" select="substring-after($reportids,$delimiter)"/>
					<xsl:with-param name="delimiter" select="$delimiter"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$scripts = ''">
						<span>
							<xsl:text/>
						</span>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$useDBURL = 'true'">
								<a class="SCRIPT script-name" target="_blank" href="/_s_/dyn/pro/DBReports_scriptReport?id={$reportids}">
									<span>
										<xsl:attribute name="title">
											<xsl:value-of select="$scripts" />
										</xsl:attribute>
										<xsl:text>
											<xsl:value-of select="$scripts" />
										</xsl:text>
									</span>
								</a>
							</xsl:when>
							<xsl:otherwise>
								<a class="SCRIPT script-name" target="_blank" href="{$reportids}.html">
									<span>
										<xsl:attribute name="title">
											<xsl:value-of select="$scripts" />
										</xsl:attribute>
										<xsl:text>
											<xsl:value-of select="$scripts" />
										</xsl:text>
									</span>
								</a>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="suiteSummary">
		<xsl:param name="suiteId" select="suiteReportId|SUITEREPORTID" />
		<xsl:param name="className" select="suitestatus|SUITESTATUS" />
		<xsl:param name="suitePath" select="suitePath|SUITEPATH" />
		<xsl:param name="startTime" select="startTime|STARTTIME" />
		<xsl:param name="totalCount" select="totalcount|TOTALCOUNT" />
		<xsl:param name="passedCount" select="passedcount|PASSEDCOUNT" />
		<xsl:param name="healedCount" select="healedCount|HEALEDCOUNT" />
		<xsl:param name="failedCount" select="failedcount|FAILEDCOUNT" />
		<xsl:param name="skippedCount" select="skippedcount|SKIPPEDCOUNT" />
		<xsl:param name="abortedCount" select="abortedCount|ABORTEDCOUNT" />
		<xsl:param name="abortedTimeoutCount" select="abortedTimeoutCount|ABORTEDTIMEOUTCOUNT" />
		<xsl:param name="notSupportedCount" select="notSupportedCount|NOTSUPPORTEDCOUNT" />
		<xsl:param name="suiteInfo" select="suiteinfo|SUITEINFO" />
		<xsl:param name="endTime" select="endTime|ENDTIME" />
		<xsl:param name="timeTaken" select="timeTaken|TIMETAKEN" />
		<xsl:param name="browserType" select="browsertype|BROWSERTYPE" />
		<xsl:param name="suiteName" select="suiteName|SUITENAME" />
		<xsl:param name="retriedsuitereportid" select="util:fetchInfo($suiteInfo, 'retriedSuiteReportId')" />
		<xsl:param name="firstrunsuitereportid" select="util:fetchInfo($suiteInfo, 'firstRunSuiteReportId')" />
		<xsl:param name="errorCount" select="ERRORCOUNT" />
		<xsl:param name="failedHealedCount" select="FAILEDHEALEDCOUNT" />
		<xsl:param name="errorHealedCount" select="ERRORHEALEDCOUNT" />
		<xsl:param name="abortedHealedCount" select="ABORTEDHEALEDCOUNT" />
		<xsl:param name="abortedTimeoutHealedCount" select="ABORTEDTIMEOUTHEALEDCOUNT" />
		<xsl:param name="internalAborted" select="INTERNALABORTED" />

		<xsl:param name="gitScriptPath" select="util:fetchInfo($suiteInfo, 'gitScriptPath')" />
		<xsl:param name="copiedScriptPath" select="util:fetchInfo($suiteInfo, 'copiedScriptsPath')" />
		<xsl:param name="suitePathGit" select="util:replaceSuitePathForGit($suitePath, $copiedScriptPath, $gitScriptPath)" />
		<xsl:param name="commitId" select="util:fetchInfo($suiteInfo, 'commitId')"/>
		<xsl:variable name="commitIdURI">
			<xsl:choose>
				<xsl:when test="$commitId !=''">
					<xsl:value-of select="concat('&amp;commitId=',$commitId)"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="''"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="lowercase" select='"abcdefghijklmnopqrstuvwxyz "' />
		<xsl:variable name="uppercase" select='"ABCDEFGHIJKLMNOPQRSTUVWXYZ_"' />

		<xsl:choose>
			<xsl:when test="$useDBURL = 'true'"> 
 				   <div id="banner"> 
 				       <div>
 				          <img src="/_s_/spr/images/caution_Icon_red.svg"/> 
 				       </div> 
 				       <div class="warn"> 
 				         <span id="warn">This Browser is not compatible. </span> 
 				         <span>Kindly switch to any modern browsers like 
 				           <strong>Google Chrome, Mozilla Firefox, Microsoft Edge, </strong><span>etc.</span> 
 				         </span> 
 				       </div> 
 				   </div> 
				<div class='navbar-container flex-row'>
					<div id='navbar' class='navbar flex-row logo-header'>
						<div class='left-nav flex-row'>
							<a class="nav-sahi-logo" onclick="window.location.href='/_s_/dyn/pro/DBReports';" style="cursor: pointer;"><span id="sahi-logo" class="bg-sahi-logo"></span></a>
							<a href='/_s_/dyn/pro/DBReports'>Suites</a>
							<div style="display:none" id="parentSuite">
								<a id="parentSuiteLink" href='/_s_/dyn/pro/DBReports_suiteReport'>Parent Suite Report</a>
							</div>
							<xsl:choose>
								<xsl:when test="$firstrunsuitereportid != 'null' and $firstrunsuitereportid != ''">
									<a class="navLink" href='/_s_/dyn/pro/DBReports_suiteReport?id={$firstrunsuitereportid}'>Suite Report</a>
								</xsl:when>
								<xsl:otherwise>
									<a class="navLink" href='/_s_/dyn/pro/DBReports_suiteReport?id={$suiteId}'>Suite Report</a>
								</xsl:otherwise>
							</xsl:choose>
							<a class="navLink" href='/_s_/dyn/pro/DBReports_testCaseReport?id={$suiteId}'>Test Cases Report</a>
							<xsl:if test="(contains($suiteName, '.csv')) and not(contains($suiteName, '.dd.csv')) and not(contains($suiteName, '.s.csv'))">
								<a class="navLink" href='/_s_/dyn/pro/DBReports_csvTestCasesReport?id={$suiteId}'>Test Cases Report Summary</a>
							</xsl:if>
							<xsl:if test="$retriedsuitereportid != 'null' and $retriedsuitereportid != ''">
								<a href='/_s_/dyn/pro/DBReports_suiteReport?id={$retriedsuitereportid}' id="linkshowretrylogs">Show retry logs</a>
							</xsl:if>
							<span id="jsCodeCoverage">
								<a href='/_s_/dyn/pro/JSCodeCoverage?suiteReportId={$suiteId}'> JS Code Coverage Report </a>
							</span>
							<a class="navLink selected" href='/_s_/dyn/pro/DBReports_failureReport?id={$suiteId}'>Suite Analysis</a>
						</div>
						<div class='flex-row right-nav'>
							<span class="container" onclick="logout()" id="logout" style="display:none;">
								<img src="/_s_/spr/images/fi-rr-log-out.svg"/>
								<a href="#" title="Log out" onclick="logout()">Log out</a>
							</span>
						</div>
					</div>
				</div>
			</xsl:when>
			<xsl:otherwise>
				<div class='navbar-container'>
					<div id='navbar' class='flex-row logo-header'>
						<div class='left-nav flex-row'>
							<span id="sahi-logo" class="bg-sahi-logo"></span>
							<a href='index.html'>Suite Report</a>
							<a href='testcase_summary.html'>Test Cases Report</a>
							<xsl:if test="(contains($suiteName, '.csv')) and not(contains($suiteName, '.dd.csv')) and not(contains($suiteName, '.s.csv'))">
								<a href='results.csv'>Test Cases Report Summary</a>
							</xsl:if>
							<xsl:if test="(number($failedCount) != 0 or number($errorCount) != 0 or number($abortedCount) != 0 or number($notSupportedCount) != 0 or number($abortedTimeoutCount) != 0) and $retriedsuitereportid != 'null' and $retriedsuitereportid != ''">
								<a href="retry/index.html" id="linkshowretrylogs">Show retry logs</a>
							</xsl:if>
							<a href='js_code_coverage_summary.html'>JS Code Coverage Report</a>
							<a href='suite_analysis_summary.html' class='selected'>Suite Analysis</a>
						</div>
					</div>
				</div>
			</xsl:otherwise>
		</xsl:choose>

		<div class='container'>
			<xsl:choose>
				<xsl:when test="count(/suites/suite)=1">
					<h1 class='suite-analysis-header'><xsl:value-of select="$suiteName" /></h1>
					<div class="suite-summary">
						<div class='suite-name flex-row'>
							<span class="flex-row" style="align-items: flex-start;">
								<span>Suite Name:</span>
								<xsl:if test="$useDBURL = 'true'">
									<a style="color:black" href="/_s_/dyn/Log_highlight?href={$suitePathGit}{$commitIdURI}">
										<xsl:value-of select="$suiteName" />
									</a>
								</xsl:if>
								<xsl:if test="not($useDBURL = 'true')">
									<a><xsl:value-of select="$suiteName" /></a>
								</xsl:if>
							</span>
						</div>
						<div class='suite-details flex-row'>
							<div class='suite-details-left flex-column'>

								<xsl:if test="$browserType != 'null' and $browserType != ''">
									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Browser Type: </span>
										<span class='suite-detail-item-value'>
											<xsl:value-of select="$browserType" />
										</span>
									</div>
								</xsl:if>

								<div class='suite-detail-group'>
									<span class='suite-detail-item-title'>Start Time: </span>
									<span class='suite-detail-item-value date-time'>
										<xsl:attribute name="data-text">
											<xsl:value-of select="util:humanTime($startTime)" />
										</xsl:attribute>
									</span>
								</div>

								<div class='suite-detail-group'>
									<span class='suite-detail-item-title'>End Time: </span>
									<span class='suite-detail-item-value date-time'>
										<xsl:attribute name="data-text">
											<xsl:value-of select="util:humanTime($endTime)" />
										</xsl:attribute>
									</span>
								</div>

								<div class='suite-detail-group'>
									<span class='suite-detail-item-title'>Time Taken: </span>
									<span class='suite-detail-item-value time-taken'>
										<xsl:attribute name="data-text">
											<xsl:copy-of select="util:prettyTimeMoreThan24Hours($timeTaken)" />
										</xsl:attribute>
									</span>
								</div>
							</div>

							<div class='suite-details-right'>
								<div class='suite-details-right-title'>
									<h2>Scripts</h2>
								</div>

								<div class='flex-column' style="gap: 0;">
									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Passed: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$passedCount != 'null'">
													<span><xsl:value-of select="$passedCount" /></span>
													<span>
														<xsl:if test="number($healedCount)">
															(<xsl:value-of select="$healedCount" /> HEALED)
														</xsl:if>
													</span>
												</xsl:when>
												<xsl:otherwise>
													NA
												</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Failed: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$failedCount != 'null'">
													<span><xsl:value-of select="$failedCount" /></span>
													<span>
														<xsl:if test="number($failedHealedCount)">
															(<xsl:value-of select="$failedHealedCount" /> HEALED)
														</xsl:if>
													</span>
												</xsl:when>
												<xsl:otherwise>
													NA
												</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Errored: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$errorCount != 'null'">
													<span><xsl:value-of select="$errorCount" /></span>
													<span>
														<xsl:if test="number($errorHealedCount)">
															(<xsl:value-of select="$errorHealedCount" /> HEALED)
														</xsl:if>
													</span>
												</xsl:when>
												<xsl:otherwise>
													NA
												</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Skipped: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$skippedCount != 'null'">
													<span><xsl:value-of select="$skippedCount" /></span>
												</xsl:when>
												<xsl:otherwise>NA</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Aborted: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$abortedCount != 'null'">
													<span><xsl:value-of select="$abortedCount" /></span>
													<span>
														<xsl:if test="number($abortedHealedCount)">
															(<xsl:value-of select="$abortedHealedCount" /> HEALED)
														</xsl:if>
													</span>
												</xsl:when>
												<xsl:otherwise>
													NA
												</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Aborted Timeout: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$abortedTimeoutCount != 'null'">
													<span><xsl:value-of select="$abortedTimeoutCount" /></span>
													<span>
														<xsl:if test="number($abortedTimeoutHealedCount)">
															(<xsl:value-of select="$abortedTimeoutHealedCount" /> HEALED)
														</xsl:if>
													</span>
												</xsl:when>
												<xsl:otherwise>
													NA
												</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Not Supported: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$notSupportedCount != 'null'">
													<span><xsl:value-of select="$notSupportedCount" /></span>
												</xsl:when>
												<xsl:otherwise>NA</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<xsl:if test="number($internalAborted)">
										<div class='suite-detail-group'>
											<span class='suite-detail-item-title'>Internal Aborted: </span>
											<span class='suite-detail-item-value'>
												<span><xsl:value-of select="$internalAborted" /></span>
											</span>
										</div>
									</xsl:if>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title'>Total: </span>
										<span class='suite-detail-item-value'>
											<xsl:choose>
												<xsl:when test="$totalCount != 'null'">
													<span><xsl:value-of select="$totalCount" /></span>
												</xsl:when>
												<xsl:otherwise>NA</xsl:otherwise>
											</xsl:choose>
										</span>
									</div>

									<div class='suite-detail-group'>
										<span class='suite-detail-item-title' style='flex-basis: 0;'>Status: </span>
										<span class="suite-detail-item-value suite-status" style="text-align: center;">
											<span id='status' class='status-icon flex-row {$className}' style="display: inline-flex; margin:0; white-space: nowrap;">
												<xsl:value-of select="translate(suitestatus|SUITESTATUS, $uppercase, $lowercase)" />
											</span>
										</span>
									</div>
								</div>
							</div>
						</div>
					</div>

					<div class='suite-info'>
						<span><a class="suiteInfoLink flex-row arrow-bg-before" href="#" onclick="showHide('suiteInfo', this);return false;">Suite Info</a></span>
						<div id="suiteInfo" style="display:none;">
							<pre>
								<xsl:value-of select="suiteInfo|SUITEINFO" />
							</pre>
						</div>
					</div>
					<div class='nodes-info'>
						<span><a class="nodesInfoLink flex-row arrow-bg-before" href="#" onclick="showHide('nodesInfo', this);return false;">Nodes Info</a></span>
						<div id='nodesInfo' style='display:none;'>
							<table class='nodes-info'>
								<thead>
									<tr class='table-header'>
										<th>Host</th>
										<th>Port</th>
										<th>Tests executed</th>
									</tr>
								</thead>
								<tbody>
									<xsl:for-each select="(nodes/node)|(NODES/NODE)">
										<tr class="table-data">
											<td>
												<xsl:value-of select="hostname|HOSTNAME" />
											</td>
											<td>
												<xsl:value-of select="port|PORT" />
											</td>
											<td>
												<xsl:value-of select="scriptCount|SCRIPTCOUNT" />
											</td>
										</tr>
									</xsl:for-each>
								</tbody>
							</table>
						</div>
					</div>
				</xsl:when>

				<xsl:otherwise>
					<h1 class='suite-analysis-header'>Suite Analysis</h1>
					<xsl:variable name="break">&lt;br&gt;</xsl:variable>
					<xsl:for-each select="/suites/suite/suiteSummary">
						<xsl:value-of disable-output-escaping="yes" select=" concat('',$break)" />
					</xsl:for-each>
					<xsl:value-of disable-output-escaping="yes" select=" concat('',$break)" />
					<xsl:value-of disable-output-escaping="yes" select=" concat('',$break)" />

					<xsl:for-each select="/suites/suite/suiteSummary">

						<xsl:variable name="checkAllSelected"><xsl:value-of select="suitename|SUITENAME" /></xsl:variable>

						<xsl:if test="$checkAllSelected != '' and $checkAllSelected != 'null' ">
							<div class="selected-suite-summary">
								<div class="suite-summary">
									<div class='suite-name'>
										<span>
											Suite Name:<xsl:value-of select="suiteName|SUITENAME" />
										</span>
									</div>
									<div class='suite-details'>
										<div class='suite-details-left'>

											<xsl:if test="$browserType != 'null' and $browserType != ''">
												<div class='suite-detail-group'>
													<span class='suite-detail-item-title'>Browser Type: </span>
													<span class='suite-detail-item-value'>
														<xsl:value-of select="browserType|BROWSERTYPE" />
													</span>
												</div>
											</xsl:if>

											<div class='suite-detail-group'>
												<span class='suite-detail-item-title'>Start Time: </span>
												<span class='suite-detail-item-value'>
													<xsl:value-of select="util:humanTime(STARTTIME)" />
												</span>
											</div>

											<div class='suite-detail-group'>
												<span class='suite-detail-item-title'>End Time: </span>
												<span class='suite-detail-item-value'>
													<xsl:value-of select="util:humanTime(ENDTIME)" />
												</span>
											</div>

											<div class='suite-detail-group'>
												<span class='suite-detail-item-title'>Time Taken: </span>
												<span class='suite-detail-item-value'>
													<xsl:value-of select="util:prettyTimeMoreThan24Hours(TIMETAKEN)" />
												</span>
											</div>
										</div>

										<div class='suite-details-right'>
											<div class='suite-details-right-title'>
												<h2>Scripts</h2>
											</div>

											<div class='suite-detail-group'>
												<span class='suite-detail-item-title'>Passed: </span>
												<span class='suite-detail-item-value'>
													<xsl:value-of select="passedCount|PASSEDCOUNT" />
												</span>
											</div>

											<div class='suite-detail-group'>
												<span class='suite-detail-item-title'>Failed: </span>
												<span class='suite-detail-item-value'>
													<xsl:value-of select="failedCount|FAILEDCOUNT" />
												</span>
											</div>

											<div class='suite-detail-group'>
												<span class='suite-detail-item-title'>Total: </span>
												<span class='suite-detail-item-value'>
													<xsl:value-of select="totalCount|TOTALCOUNT" />
												</span>
											</div>

											<div class='suite-detail-group'>
												<span class='suite-detail-item-title'>Status: </span>
												<span id='status' class="suite-detail-item-value suite-status status-icon flex-row {$className}">
													<xsl:value-of select="suitestatus|SUITESTATUS" />
												</span>
											</div>
										</div>
									</div>
								</div>

								<div class='suite-info'>
									<span><a id="suiteInfoLink" href="#" onclick="showHide('suiteInfo');return false;">Suite Info</a></span>
									<div id="suiteInfo" style="display:none;">
										<pre>
											<xsl:value-of select="suiteInfo|SUITEINFO" />
										</pre>
									</div>
								</div>
								<div class='nodes-info'>
									<span><a id="nodesInfoLink" href="#" onclick="showHide('nodesInfo');return false;">Nodes Info</a></span>
									<div id='nodesInfo' style='display:none;'>
										<table class='nodes-info'>
											<thead>
												<tr>Host</tr>
												<tr>Port</tr>
												<tr>Tests executed</tr>
											</thead>
											<tbody>
												<xsl:for-each select="(nodes/node)|(NODES/NODE)">
													<tr>
														<td>
															<xsl:value-of select="hostname|HOSTNAME" />
														</td>
														<td>
															<xsl:value-of select="port|PORT" />
														</td>
														<td>
															<xsl:value-of select="scriptCount|SCRIPTCOUNT" />
														</td>
													</tr>
												</xsl:for-each>
											</tbody>
										</table>
									</div>
								</div>
							</div>
							<table class="suite_summary" style="width:850px;">
								<tr><th colspan="8" style="text-align:left"><xsl:value-of select="suitename|SUITENAME" /></th></tr>
								<tr>
									<td>
										<xsl:value-of select="browserType|BROWSERTYPE" />
									</td>
									<td>
										<xsl:value-of select="util:humanTime(STARTTIME)" />
									</td>
									<td>
										<xsl:value-of select="util:humanTime(ENDTIME)" />
									</td>
									<td>
										<xsl:value-of select="util:prettyTimeMoreThan24Hours(TIMETAKEN)" />
									</td>
									<td>
										<xsl:value-of select="totalCount|TOTALCOUNT" />
									</td>
									<td>
										<xsl:value-of select="passedCount|PASSEDCOUNT" />
									</td>
									<td>
										<xsl:value-of select="failedCount|FAILEDCOUNT" />
									</td>
									<td>
										<xsl:value-of select="suitestatus|SUITESTATUS" />
									</td>
									<td>
										<a style="color:blue;text-decoration:underline" href="#" onclick="showHide('suiteInfo_{position()}');return false;">Suite Info</a><br/>
										<div id="suiteInfo_{position()}" style="display:none;">
											<pre>
												<xsl:value-of select="suiteInfo|SUITEINFO" />
											</pre>
										</div>
									</td>
									<td>
										<a style="color:blue;text-decoration:underline" href="#" onclick="showHide('nodesInfo_{position()}');return false;">Nodes Info</a><br/>
										<div id="nodesInfo_{position()}" style="display:none;">
											<table style="width:550px;">
												<tr>
													<td>Host</td>
													<td>Port</td>
													<td>Tests executed</td>
												</tr>

												<xsl:for-each select="(nodes/node)|(NODES/NODE)">
													<tr>
														<td>
															<xsl:value-of select="hostname|HOSTNAME" />
														</td>
														<td>
															<xsl:value-of select="port|PORT" />
														</td>
														<td>
															<xsl:value-of select="scriptCount|SCRIPTCOUNT" />
														</td>
													</tr>
												</xsl:for-each>
											</table>
										</div>
									</td>
								</tr>
							</table>
						</xsl:if>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</div>

		<script>
			var _isCollapse = undefined;
			var _expandedIds = [];
			var _cookiesExpandedIds = undefined;
			var useDBURL = '<xsl:value-of select="($useDBURL)"/>';
			var suiteReportID = '<xsl:value-of select="$suiteId"/>';
			var commitIdURI = "<xsl:value-of select="$commitIdURI"/>";
			var gitLogEnabled = <xsl:value-of select="util:isGitLogIntegrationEnabled()" />;
			var gitScriptPath = "<xsl:value-of select="$gitScriptPath"/>";
			var timer = 1;
			var cookieHashMap = {};

			<![CDATA[
			function readCookie(name){
				var nameEQ = name + "=";
				var ca = document.cookie.split(';');
				for(var i=0;i<ca.length;i++){
					var c = ca[i];
					c = c.replace(/[,][}]$/,'}');
					while (c.charAt(0)==' ') c = c.substring(1,c.length);
					if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
				}
				return null;
			}

			var queryStringObject = function () { //returns URL QueryString parameters as a JSON object
			  var query_string = {};
			  var query = window.location.search.substring(1);
			  var vars = query.split("&");
			  for (var i=0;i<vars.length;i++) {
			    var pair = vars[i].split("=");
			        query_string[pair[0]] = pair[1];
			  }
			    return query_string;
			}();

			if(queryStringObject && queryStringObject["mainSuiteId"]){
				document.getElementById("jsCodeCoverage").style.display = "none";
				document.getElementById("sahiCodeCoverage").style.display = "none";
				document.getElementById("nodeAnalysis").style.display = "none";
				document.getElementById("parentSuite").style.display = "inline";
				document.getElementById("suiteInfoLink").style.display="none";
				document.getElementById("nodesInfoLink").style.display="none";
				document.getElementById("parentSuiteLink").href += ("?id="+queryStringObject["mainSuiteId"]);
				var navLinks = document.getElementsByClassName("navLink");
				for(var i=0; i<navLinks.length; i++){
					navLinks[i].href += ("&mainSuiteId="+queryStringObject["mainSuiteId"]);
				}
			}

			function createCookie(name,value,days){
				if (days) {
					var date = new Date();
					date.setTime(date.getTime()+(days*24*60*60*1000));
					var expires = "; expires="+date.toGMTString();
				}
				else var expires = "";
				document.cookie = name+"="+value+expires+"; path=/";
			}

			function showHide(s, thisEl) {
				var el=document.getElementById(s);
				el.style.display = (el.style.display == 'block') ? 'none' : 'block';
				thisEl.classList.toggle('expanded');
			};

			function onLoad(){
				if(useDBURL == "true"){
		        	showLogoutIfUserLoggedIn();
		        }

				splitStartAndEndTimeColumns();
				formatTimeTakenColumn();

		        var cookieValue = readCookie("expandedSuiteAnalysisDetails");
				if(cookieValue){
					try {
						cookieHashMap = eval("("+cookieValue+")");
					} catch(e) {
						cookieHashMap = {[suiteReportID]: []};
					}
					var cookieAr = cookieHashMap[suiteReportID];
					expandIds(cookieAr);
				}

				reportsCookie("_showFailureReportCookie", "failureReport");
				reportsCookie("_showHealedReportCookie", "healedReport");
			}

			function reportsCookie(cookiename, reportName){
				var cookieValue = readCookie(cookiename);
				if(cookieValue){
					cookieHashMap = eval("("+cookieValue+")");
					var showReport = cookieHashMap[suiteReportID];
					if(showReport === false || showReport === true){
					 	document.getElementById(reportName).checked = showReport;
					 	showHideReports(document.getElementById(reportName));
					}
				}
			}

			function onUnload(){
				var count = 0;
				var firstElement;
				for(firstElement in cookieHashMap){
					break;
				}
				for(var j in cookieHashMap){
					count++;
				}
				if(count == 10){
					delete cookieHashMap[firstElement];
				}
				var cookieValue = readCookie("expandedSuiteAnalysisDetails");
				if(cookieValue){
					try {
						cookieHashMap = eval("("+cookieValue+")");
					} catch(e) {
						cookieHashMap = { [suiteReportID]: [] };
					}
				}
				cookieHashMap[suiteReportID] = _expandedIds;
				cookieValue = getJSON(cookieHashMap);
				createCookie("expandedSuiteAnalysisDetails", cookieValue, 1);

				cookieValue = readCookie("_showFailureReportCookie");
				if(cookieValue){
					cookieHashMap = eval("("+cookieValue+")");
				}
				cookieHashMap[suiteReportID] = document.getElementById("failureReport").checked;
				cookieValue = getJSON(cookieHashMap, true);
				createCookie("_showFailureReportCookie", cookieValue, 1);

				cookieValue = readCookie("_showHealedReportCookie");
				if(cookieValue){
					cookieHashMap = eval("("+cookieValue+")");
				}
				cookieHashMap[suiteReportID] = document.getElementById("healedReport").checked;
				cookieValue = getJSON(cookieHashMap, true);
				createCookie("_showHealedReportCookie", cookieValue, 1);
			}

			function arrToString(ar) {
				var s = "[";
				for (var i = 0; i < ar.length; i++) {
					s += "\"";
					s += ar[i];
					s += "\"";
					if (i != ar.length - 1)
						s += ",";
				}
				s += "]";
				return s;
			}

			function getJSON(o, isValueWithoutArray) {
				var s = "{";
				for (var i in o) {
					if(isValueWithoutArray) s += "'" + i + "':" + o[i] + ",";
					else s += "'" + i + "':[" + o[i].map(x => x.id ? `'${x.id}'`:`'${x}'`).join(',') + "],";
				}
				if(s.indexOf(",", s.length - 1) > -1) s = s.substring(0, s.length - 1);
				s += "}";
				return s;
			}

			onkeydown = function(e){
				e = !e ? window.event : e;
				if (e.keyCode == 27) {
					if(!jQuery('#all_steps_div').window('options').closed)
						closeWindow("all_steps_div");
				}
			}

			function scrollRight(div){
				var s = $(div).scrollLeft();
				//if(sahiIsIE()) or edge.
				s = s-1;
				var table = $(div).children(".no-border");
				table[0].style.right = -s;
			}

			function clickOnAllTreeDetails(){
				$(".details").each(function () {
			        $(this).click();
			    });
			}

			function expandIds(ids){
				if(!ids) return;
				_cookiesExpandedIds = ids;
				clickOnAllTreeDetails();
				_cookiesExpandedIds = undefined;
			}

			function expandAll(isExpand){
				if(isExpand) _isCollapse = false;
				else _isCollapse = true;
				clickOnAllTreeDetails();
			    _isCollapse = undefined;
			}

			function openTreeDetails(buttonId, id, treeData){
				if(_cookiesExpandedIds){
					var isIdInArray = (sahiFindInArray(_cookiesExpandedIds, id) == -1)? false : true ;
					if(!isIdInArray) return;
				}

				var thisButton = document.getElementById(buttonId)

				var panel = $("#"+id).parent();
				if(panel.panel('options').collapsed){
					if(_isCollapse) return;
					thisButton.innerText = 'Hide Tree Diagram';
					panel.panel('expand');
					if(sahiFindInArray(_expandedIds, id) == -1) _expandedIds.push(id);
					if($("#"+id).children().length == 1) return;
				}
				else {
					if(_isCollapse === false) return;
					thisButton.innerText = 'View Tree Diagram';
					panel.panel('collapse');
					var indexOfId = sahiFindInArray(_expandedIds, id);
					if(indexOfId != -1) _expandedIds.splice(indexOfId, 1);
					return;
				}
				if(treeData == null) return;
				var treeHeight = treeData[0].rootHeight;
				if(treeHeight > 1) height = treeHeight*60;
				else height = getSvgHeight();
				panel.panel('resize',{
					height: height+150,
					width: panel.width() + 20
				});
				var rootDepth = treeData[0].rootDepth + 1;
				var treeWidth = rootDepth * 270;
				var svgWidth = getSvgWidth();
				if(svgWidth < treeWidth) width = treeWidth;
				else width = svgWidth;
				if(rootDepth == 3) width = width - 125;
				var svg = d3.select("#"+id).append("svg")
					.attr("width", width + margin.right + margin.left)
					.attr("height", height + margin.top + margin.bottom);
				var g = svg.append("g")
					.attr("transform", "translate(" + margin.left + "," + margin.top + ")");
				var root = treeData[0];
				root.x0 = height / 2;
				root.y0 = width;
				update(root, root, g, [height, width]);
			}

			function openStepsWindow(id, messages, link){
				var msg = "";
		  		for(var i=0; i<messages.length; i++){
		  			msg += messages[i];
		  			if(i != messages.length-1) msg += "\r\n";
		  		}
		  		document.getElementById("failuresText").value = msg;
		  		storeTextAreaValueInEditor("failuresText");
				openWindow(id, link);
				var div = document.getElementById(id);
				div.scrollTop = 0;
				//Refreshing 2 times to avoid fluctuation in UI.
		  		refreshInCME("failuresText");
		  		refreshInCME("failuresText");
			}

			function openWindow(id, link){
				jQuery('#'+id).window('open');
				var height = 65;
				if(screen && screen.availHeight && screen.availHeight > 1000) height = 200;
				jQuery('#'+id).window('window').css({'position': 'fixed', top: height});
	  		}
			function closeWindow(id){
				jQuery('#'+id).window('close');
			}

			function writeStepMessage(failureId, messages, debuginfo){
				var msg = messages[0];
				if(msg){
					var link = createLink(failureId, msg, debuginfo);
					link.id = "message-" + failureId;
				}
			}

			function createLink(parentId, text, debuginfo){
				var link = document.createElement("a");
				if(useDBURL){
					var path = debuginfo;
					if(gitLogEnabled && path) path = path.replace(/^temp\/scripts\/staging\//g, gitScriptPath);
					link.setAttribute("href", "/_s_/dyn/Log_highlight?href=" + path + commitIdURI);
					link.target = "_blank";
				}
				if(text == "") {
					var sIndex = debuginfo.lastIndexOf("/") + 1;
					if(!(sIndex > -1)) sIndex = debuginfo.lastIndexOf("\\") + 1;
					if(sIndex == -1) sIndex = 0;
					text = debuginfo.substring(sIndex, debuginfo.indexOf("&"));
				}
				var linkText = document.createTextNode(text);
				link.appendChild(linkText);
				document.getElementById(parentId).appendChild(link);
				return link;
			}

			function getSvgWidth(){
				var w = ($(document).width() * 0.96) - 100;
				return w - margin.right - margin.left;
			}

			function getSvgHeight(){
				var h = 80;
				return h - margin.top - margin.bottom;
			}

			var margin = {top: 1, right: 400, bottom: 1, left: 200},
			width = getSvgWidth(),
			height = getSvgHeight();

			var duration = 750;

			var diagonal = d3.svg.diagonal()
				.projection(function(d) { return [d.y, d.x]; });

			//d3.select(self.frameElement).style("height", "500px");

			function update(source, root, svg, dimension) {
				var nodeStartId = 0;
				var tree = d3.layout.tree()
				.size(dimension);
			  // Compute the new tree layout.
			  var nodes = tree.nodes(root).reverse(),
				  links = tree.links(nodes);

			  // Normalize for fixed-depth from right.
			  nodes.forEach(function(d) { d.y = dimension[1] - (d.depth * 305); });

			  // Update the nodes…
			  var node = svg.selectAll("g.node")
				  .data(nodes, function(d) { return d.id || (d.id = ++nodeStartId); });

			  // Enter any new nodes at the parent's previous position.
			  var nodeEnter = node.enter().append("g")
				  .attr("class", "node")
				  .attr("transform", function(d) { return "translate(" + source.y0 + "," + source.x0 + ")"; });

			  nodeEnter.append("circle")
				  .attr("r", 1e-6)
				  <!-- .style("fill", function(d) { return d._children ? "lightsteelblue" : "#fff"; }) -->
				  .on("click", function (d) {
					  	var nodeClick = clickOnCircle.bind(this);
					  	nodeClick(d, root, dimension);
				   });

			  nodeEnter.append("text")
				  .text(function(d) { return d.occurrence; })
				  .attr("dx", function(d) { return d.occurrence < 10 ? -4 : d.occurrence < 100 ? -8 : d.occurrence < 1000 ? -11 : -14; })
				  .attr("dy", "5")
				  .on("click", function (d) {
					  	var nodeClick = clickOnCircle.bind(this);
					  	nodeClick(d, root, dimension);
				   });

			  var text = nodeEnter.append("text")
				  .attr("class", "ste")
				  .attr("x", function(d) { return d.children || d._children ? 22 : -22; })
				  //.attr("dy", ".35em")
				  .attr("text-anchor", function(d) { return d.children || d._children ? "start" : "end"; })
				  .text(function(d) { return d.name })
				  .on("click", openLink)
				  .call(wrapText, 300);

			  text.append("title").text(function(d) {
					var line = "line";
					var nodeName = d.name;
					if(isScenario(nodeName)) line = "row";
					return d.name + (d.lineNumber != -1 ? (", " + line + "=" + d.lineNumber) : "");
				});

			  text.append("tspan")
				.text(function(d) {
					var line = "line";
					var nodeName = d.name;
					if(isScenario(nodeName)) line = "row";
					return (d.lineNumber != -1 ? (line + "=" + d.lineNumber) : "");
				})
				.attr("x", function(d) { return d.children || d._children ? 22 : -22; })
			    .attr("dy", 13.65);

			  // Transition nodes to their new position.
			  var nodeUpdate = node.transition()
				  .duration(duration)
				  .attr("transform", function(d) { return "translate(" + d.y + "," + d.x + ")"; });

			  nodeUpdate.select("circle")
				  .attr("r", 16)
				  <!-- .style("fill", function(d) { return d._children ? "lightsteelblue" : "#fff"; }); -->

			  nodeUpdate.select("text")
				  .style("fill-opacity", 1);

			  // Transition exiting nodes to the parent's new position.
			  var nodeExit = node.exit().transition()
				  .duration(duration)
				  .attr("transform", function(d) { return "translate(" + source.y + "," + source.x + ")"; })
				  .remove();

			  nodeExit.select("circle")
				  .attr("r", 1e-6);

			  nodeExit.select("text")
				  .style("fill-opacity", 1e-6);

			  // Update the links…
			  var link = svg.selectAll("path.link")
				  .data(links, function(d) { return d.target.id; });

			  // Enter any new links at the parent's previous position.
			  link.enter().insert("path", "g")
				  .attr("class", "link")
				  .attr("d", function(d) {
					var o = {x: source.x0, y: source.y0};
					return diagonal({source: o, target: o});
				  });

			  // Transition links to their new position.
			  link.transition()
				  .duration(duration)
				  .attr("d", diagonal);

			  // Transition exiting nodes to the parent's new position.
			  link.exit().transition()
				  .duration(duration)
				  .attr("d", function(d) {
					var o = {x: source.x, y: source.y};
					return diagonal({source: o, target: o});
				  })
				  .remove();

			  // Stash the old positions for transition.
			  nodes.forEach(function(d) {
				d.x0 = d.x;
				d.y0 = d.y;
			  });
			}

			function openLink(d) {
				if(useDBURL){
					var path = d.debugInfo;
					if(gitLogEnabled && path) path = path.replace(/^temp\/scripts\/staging\//g, gitScriptPath);
					var link = "/_s_/dyn/Log_highlight?" + (!(d.isRoot)?"parsed=true&":"") + commitIdURI + "&href=";
					window.open(link + path, '_blank').focus();
				}
			}

			function clickOnCircle(d, root, dimension) {
				var g = $(this).parent().parent()[0];
				var svg = d3.select(g);
				if (d.children) {
					d._children = d.children;
					d.children = null;
			  	} else {
					d.children = d._children;
					d._children = null;
			  	}
			  	update(d, root, svg, dimension);
			}

			function isScenario(name){
				if(name && (name.match(".s.csv$") == ".s.csv" || name.match(".xls$") == ".xls" || name.match(".xlsx$") == ".xlsx")) return true;
				return false;
			}

			function wrapText(text, width) {
				if(text.length == 0) return;
				var text = text[0][text[0].length-1];
				text = d3.select(text);
				if(!text[0][0]) return;
				var words = text.text().split(/\s+/).reverse();
				var word;
				var spanText = [];
				var textHeight = 13;
				var	x = text.attr("x");
				var	y = text.attr("y");
				text.text("");
				var	svgSpan = addTSpan(text, x, y);
				while (word = words.pop()) {
					spanText.push(word);
					svgSpan.text(spanText.join(" "));
					if (svgSpan.node().getComputedTextLength() > width) {
						spanText.pop();
						svgSpan.text(spanText.join(" "));
						spanText = [word];
						svgSpan = addTSpan(text, x, y);
						svgSpan.attr("dy", textHeight).text(word);
					}
				}
			}

			function addTSpan(parent, x, y){
				var	tSpan = parent.append("tspan")
					.attr("x", x)
					.attr("y", y);
				return tSpan;
			}

			function sahiFindInArray(ar, el){
			    for (var i=0; i<ar.length; i++){
			        if (ar[i] == el) return i;
					if (ar[i].id && ar[i].id == el) return i;
			    }
			    return -1;
			}

			function enableDisableAutoRefresh(autoRefresh){
				var isAutoRefreshEnable = autoRefresh.checked;
				if(isAutoRefreshEnable){
					createCookie("auto_refresh","true",1);
					refreshPage();
					autoRefresh.title = "Disable Auto Refresh";
				} else{
					createCookie("auto_refresh","false",1);
					autoRefresh.title = "Enable Auto Refresh";
					if(timer) clearTimeout(timer);
				}
			}

			function refreshPage(){
				if(useDBURL == "false") return;
				var el = document.getElementById("status");
				if (el && (el.className == "SUCCESS" || el.className == "FAILURE" || el.className == "USER_ABORTED" || el.className == "ABORTED_TIMEOUT")){
					return;
				}
				var isAutoRefreshCookieEnable = (readCookie("auto_refresh") == "true");
				if(isAutoRefreshCookieEnable) timer = window.setTimeout("window.location.reload();", 2000);
			}

			]]>
		</script>
	</xsl:template>

	<xsl:template match="suite/failures">
		<xsl:if test="node()">
			<div class='failure-healed-report'>
				<div style="margin-bottom: 20px;" class="report-options-checkbox flex-row">
					Show:
					<span class='checkbox-group flex-row'>
						<label for="failureReport">Failure Report</label>
						<input type="checkbox" style="vertical-align:middle" checked="true" value="failureReport" id="failureReport" onchange="showHideReports(this)"/>
					</span>
					<span class='checkbox-group flex-row'>
						<label for="healedReport">Healed Report</label>
						<input type="checkbox" style="vertical-align:middle" checked="true" value="healedReport" id="healedReport" onchange="showHideReports(this)"/>
					</span>
				</div>
				<div id="currentSuiteReport">
					<div id="shownReportsText" style="margin-bottom: 20px;">
						<b><span id="selectedReport">Failure &amp; Healed</span> Report (for current Suite run)</b>
						<a id="expandAllButton"  href="javascript:void(0)" onclick="javascript:expandAll(true); return false;">Expand All</a>
						<a id="collapseAllButton" href="javascript:void(0)" onclick="javascript:expandAll(false); return false;">Collapse All</a>
					</div>
					<table id="failedSuiteByLines" class="scriptSummaries" style="width:99.5%;margin-top:10px;margin-bottom:30px;background:white;">
						<xsl:for-each select="failure">
							<xsl:param name="line" select="LINE" />
							<xsl:param name="stepmessage" select="STEPMESSAGE" />
							<xsl:param name="failuremessages" select="FAILUREMESSAGES" />
							<xsl:param name="healedmessages" select="HEALEDMESSAGES" />
							<xsl:param name="msgtype" select="MESSAGESUBTYPE" />
							<tr class="row {$msgtype}">
								<td class="failureStepMessages" style="border-right-width:0px;position:relative">
									<div class="failure-stepl-message" style="position: relative;">
										<div id="failure-{position()}" class="failure-step">
											Step:
											<script>
												var failureId = "failure-" + <xsl:value-of select="position()"/>;
												var sMsg = <xsl:value-of select="$stepmessage"/>;
												var line = "<xsl:value-of select="$line"/>";
												writeStepMessage(failureId, sMsg, line);
											</script>
										</div>
										<div class="num-failures-healed">
											Caused <a href="#!" onclick="openStepsWindow('all_steps_div', {$stepmessage}, this)" class="step-messages SCRIPT easyui-tooltip" title="Click to see all steps."><xsl:value-of disable-output-escaping="yes" select="num_steps|NUM_STEPS"/></a>
											<xsl:choose>
												<xsl:when test="$failuremessages != 'null' and $healedmessages != 'null'">
													failures and autoheals in <xsl:value-of disable-output-escaping="yes" select="num_scripts|NUM_SCRIPTS" /> scripts.
													<div class="button-view-tree">
														<a href="#!" id="button-view-tree-{position()}" onclick="openTreeDetails('button-view-tree-{position()}', 'fail_details_{position()}', {$failuremessages})" style="margin-bottom:5px;" class="details healed">View Tree Diagram</a>
													</div>
												</xsl:when>
												<xsl:when test="$failuremessages != 'null' ">
													failures in <xsl:value-of disable-output-escaping="yes" select="num_scripts|NUM_SCRIPTS" /> scripts.
													<div class="button-view-tree">
														<a href="#!" id="button-view-tree-{position()}" onclick="openTreeDetails('button-view-tree-{position()}', 'fail_details_{position()}', {$failuremessages})" style="margin-bottom:5px;" class="details failure">View Tree Diagram</a>
													</div>
												</xsl:when>
												<xsl:when test="$healedmessages != 'null' ">
													autoheals in <xsl:value-of disable-output-escaping="yes" select="num_scripts|NUM_SCRIPTS" /> scripts.
													<div class="button-view-tree">
														<a href="#!" id="button-view-tree-{position()}" onclick="openTreeDetails('button-view-tree-{position()}', 'fail_details_{position()}', {$healedmessages})" style="margin-bottom:5px;" class="details healed">View Tree Diagram</a>
													</div>
												</xsl:when>
												<xsl:otherwise>
													<xsl:param name="failuremessages2" select="'null'" />
													<div class="button-view-tree">
														<a href="#!" id="button-view-tree-{position()}" onclick="openTreeDetails('button-view-tree-{position()}', 'fail_details_{position()}', {$failuremessages2})" style="margin-bottom:5px;" class="details">View Tree Diagram</a>
													</div>
												</xsl:otherwise>
											</xsl:choose>
										</div>
										<div class="easyui-panel" style="display:none;width:100%;padding:10px;" data-options="collapsed:true">
											<div id="fail_details_{position()}"></div>
											<div class="failed-scripts-table no-border">
												<table style="background:white;">
													<thead>
														<tr style="text-align:center;">
															<th class="failed_scripts">
																Affected Script Reports
															</th>
														</tr>
													</thead>
													<tbody>
														<tr style="text-align:center;">
															<td class="failed_scripts">
																<div class="scrollable">
																	<xsl:call-template name="tokenizeString">
																		<xsl:with-param name="scripts" select="failed_scripts|FAILED_SCRIPTS"/>
																		<xsl:with-param name="reportids" select="failed_script_reportids|FAILED_SCRIPT_REPORTIDS"/>
																		<xsl:with-param name="delimiter" select="','"/>
																	</xsl:call-template>
																</div>
															</td>
														</tr>
													</tbody>
												</table>
											</div>
										</div>
									</div>
								</td>
							</tr>
						</xsl:for-each>
					</table>
				</div>
			</div>
		</xsl:if>
	</xsl:template>

	<xsl:template match="suite/failureHistory">
		<br/>
		<h2 style="margin: 10px 0;">Failed Scripts History</h2>
		<div style="margin: 20px 0;">Scripts which failed in this run, and their status across previous runs.</div>
		<xsl:param name="rowCount" select="count(failedScript|FAILEDSCRIPT)" />
		<table cellspacing="4" cellpadding="4" id="failedScriptsHistory" class="scriptSummaries">
			<tr class='table-header'>
				<th rowspan="2">Failed Scripts</th>
				<th colspan="2">Within the same Suite
					<div class="footnote">Within runs of the same Suite</div>
				</th>
				<th colspan="2">
					Within Sahi
					<div class="footnote">Within all runs across all Suites</div>
				</th>
			</tr>
			<tr class='table-header'>
				<th style="white-space:normal;width: 125px;">Pass percentage</th>
				<th>Latest status (recent to old)</th>
				<th style="white-space:normal;width: 125px;">Pass percentage</th>
				<th>Latest status (recent to old)</th>
			</tr>
			<xsl:for-each select="failedScript">
				<tr>
					<td class='script-name'>
						<span>
							<xsl:attribute name="title">
								<xsl:value-of select="scriptName|SCRIPTNAME"/>
							</xsl:attribute>
							<xsl:text>
								<xsl:value-of select="scriptName|SCRIPTNAME"/>
							</xsl:text>
						</span>					
					</td>
					<td class='right-align'>
						<xsl:value-of select="round(passPercentage|PASSPERCENTAGE*10) div 10"/>%
					</td>
					<td>
						<div style="display: block;">
							<span class='failure-history-latest-status'>
								<xsl:attribute name="data-options">
									<xsl:value-of select="latestStatus|LATESTSTATUS"/>
								</xsl:attribute>
							</span>
						</div>
					</td>
					<td class='right-align'>
						<xsl:value-of select="round(allpassPercentage|ALLPASSPERCENTAGE*10) div 10"/>%
					</td>
					<td>
						<div style="display: block;">
							<span class='failure-history-all-status' >
								<xsl:attribute name="data-options">
									<xsl:value-of select="alllatestStatus|ALLLATESTSTATUS"/>
								</xsl:attribute>
							</span>
						</div>
						<!-- <script></script> -->
					</td>
				</tr>
			</xsl:for-each>
		</table>
		<script>
			<![CDATA[
			showFullScriptStatuses('.failure-history-all-status', 'options');
			showFullScriptStatuses('.failure-history-latest-status', 'options');
		]]>
		</script>

	</xsl:template>

	<xsl:template match="suite/successHistory">
		<br/>
		<h2 style="margin: 10px 0;">Passed Scripts With Failure History</h2>
		<div style="margin: 20px 0;">History of Scripts which passed in this run, but have failed before.</div>
		<xsl:param name="rowCount" select="count(failedScript|FAILEDSCRIPT)" />
		<table cellspacing="4" cellpadding="4" id="successScriptsHistory" class="scriptSummaries">
			<tr class="table-header">
				<th rowspan="2">Passed Scripts</th>
				<th colspan="2">
					Within the same Suite
					<div class="footnote">Within runs of the same Suite</div>
				</th>
				<th colspan="2">
					Within Sahi
					<div class="footnote">Within all runs across all Suites</div>
				</th>
			</tr>
			<tr class="table-header">
				<th style="white-space:normal;width: 125px;">Pass percentage</th>
				<th>Latest status (recent to old)</th>
				<th style="white-space:normal;width: 125px;">Pass percentage</th>
				<th>Latest status (recent to old)</th>
			</tr>
			<xsl:for-each select="failedScript">
				<tr>
					<td class='script-name'>
						<span>
							<xsl:attribute name="title">
								<xsl:value-of select="scriptName|SCRIPTNAME"/>
							</xsl:attribute>
							<xsl:text>
								<xsl:value-of select="scriptName|SCRIPTNAME"/>
							</xsl:text>
						</span>
					</td>
					<td class='right-align'>
						<xsl:value-of select="round(passPercentage|PASSPERCENTAGE*10) div 10"/>%
					</td>
					<td>
						<div>
							<span class='success-history-latest-status'>
								<xsl:attribute name="data-options">
									<xsl:value-of select="latestStatus|LATESTSTATUS"/>
								</xsl:attribute>
							</span>
						</div>
					</td>
					<td class='right-align'>
						<xsl:value-of select="round(allpassPercentage|ALLPASSPERCENTAGE*10) div 10"/>%
					</td>
					<td>
						<div>
							<span class='success-history-all-status'>
								<xsl:attribute name="data-options">
									<xsl:value-of select="alllatestStatus|ALLLATESTSTATUS"/>
								</xsl:attribute>
							</span>
						</div>
					</td>
				</tr>
			</xsl:for-each>
		</table>
		<script><![CDATA[
			showFullScriptStatuses('.success-history-latest-status', 'options');
			showFullScriptStatuses('.success-history-all-status', 'options');
		]]></script>
	</xsl:template>
</xsl:stylesheet>